package immibis.infinitubes;

import immibis.core.api.util.Dir;
import immibis.core.microblock.MicroblockSystem;
import immibis.core.microblock.ItemCoverableBase;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import cpw.mods.fml.common.registry.LanguageRegistry;

public class InfiniTubeItem extends ItemBlock {

	public InfiniTubeItem(int id_minus_256) {
		super(id_minus_256);
		
		LanguageRegistry.addName(new ItemStack(this, 1, 0), "Transport conduit");
	}
	
	@Override
	public String getItemNameIS(ItemStack par1ItemStack) {
		return "immibis.infinitube." + par1ItemStack.getItemDamage();
	}
	
	@Override
	public boolean onItemUse(ItemStack stack, EntityPlayer ply, World w, int x, int y, int z, int side, float hitX, float hitY, float hitZ) {
		int oldBlockID = w.getBlockId(x, y, z);
		if(
			(MicroblockSystem.microblockContainerBlock == null || oldBlockID != MicroblockSystem.microblockContainerBlock.blockID)
			&& oldBlockID != 0 && !Block.blocksList[oldBlockID].isBlockReplaceable(w, x, y, z)) {
			switch(side) {
			case Dir.NX: x--; break;
			case Dir.PX: x++; break;
			case Dir.NY: y--; break;
			case Dir.PY: y++; break;
			case Dir.NZ: z--; break;
			case Dir.PZ: z++; break;
			}
			if(!w.blockExists(x, y, z))
				return false;
			
			oldBlockID = w.getBlockId(x, y, z);
			
			if(oldBlockID != 0 && !Block.blocksList[oldBlockID].isBlockReplaceable(w, x, y, z))
				return false;
		}
		
		if(MicroblockSystem.microblockContainerBlock != null && oldBlockID == MicroblockSystem.microblockContainerBlock.blockID) {
			if(!w.isRemote)
				if(ItemCoverableBase.mergeIntoMicroblockContainer(stack, ply, w, x, y, z, side, shiftedIndex))
					stack.stackSize--;
			return true;
		}
		
		w.setBlockWithNotify(x, y, z, shiftedIndex);
		stack.stackSize--;
		return true;
	}
	
	@Override
	public boolean canPlaceItemBlockOnSide(World par1World, int par2, int par3, int par4, int par5, EntityPlayer par6EntityPlayer, ItemStack par7ItemStack) {
		return true;
	}

}
