package immibis.infinitubes;

import immibis.core.BlockCombined;
import immibis.core.api.util.Dir;

import java.util.ArrayList;

import net.minecraft.block.material.Material;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class MachineBlock extends BlockCombined {
	public MachineBlock(int id) {
		super(id, Material.iron, "/immibis/infinitubes/world.png");
	}

	@Override
	public int getBlockTextureFromSideAndMetadata(int side, int data) {
		if(data == 0) {
			return side + 17;
		} else if(data == 1) {
			if(side == Dir.PY)
				return 16;
			else if(side == Dir.NY)
				return 48;
			else
				return 32;
		}
		return 0;
	}
	
	@Override
	public int getBlockTexture(IBlockAccess par1iBlockAccess, int par2, int par3, int par4, int par5) {
		TileEntity te = par1iBlockAccess.getBlockTileEntity(par2, par3, par4);
		if(te instanceof TransporterTile) {
			TransporterTile tt = (TransporterTile)te;
			if(par5 == tt.inputSide)
				return 1 + par5;
			else if(par5 == tt.outputSide)
				return 33 + par5;
			else
				return 17 + par5;
		}
		if(te instanceof PowerJunctionTile) {
			if(par5 == Dir.PY)
				return 16;
			else if(par5 == Dir.NY)
				return 48;
			else
				return 32;
		}
		return 0;
	}

	@Override
	public TileEntity getBlockEntity(int data) {
		try {
			switch(data) {
			case 0: return new TransporterTile();
			case 1: return new PowerJunctionTile();
			default: return null;
			}
		} catch(Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public void addCreativeItems(ArrayList arraylist) {
		arraylist.add(new ItemStack(this, 1, 0));
		arraylist.add(new ItemStack(this, 1, 1));
	}
	
	@Override
	public void onBlockAdded(World world, int x, int y, int z) {
		super.onBlockAdded(world, x, y, z);
		WorldTubeMap.getForWorld(world).addMachine(x, y, z);
	}
	
	@Override
	public void breakBlock(World world, int x, int y, int z, int blockID, int meta) {
		WorldTubeMap.getForWorld(world).removeMachine(x, y, z);
		super.breakBlock(world, x, y, z, blockID, meta);
	}
}
